#ifndef BateauH
#define BateauH

#include <math.h>

#define PI 3.1415926535897932384626433832795f
#define RadToDeg 180.0f/PI
#define DegToRad PI/180
#define PI_sur_180 PI/180.0f
#define EP_GOUV 0.1
# define HAUTEUR_MAT 14
# define HAUTEUR_COQUE 1.0f
#define PORT "COM6"   //pour voir le port : Windows/gestionnaire de priphrique/ port COM   
//#define K   0.786555
#define K 0.4
//#define K   4
#define Cp  0.03
#define Rm  1.09e9f
#define Rm 6
#define COEFF_VITESSE 1
#define COEFF_FILTRE 1
#define T_CALCUL 200
#define TENSION_MOTEUR 15.0
#define DELTAV_MAX PI/2.0

#define SIGN(a) ((abs(a)<0.001) ? 0 : a/abs(a))


#include "glut.h"

#include <stdio.h>
#include <stdlib.h>

//#define MAX(a,b) (((a) >= (b)) ? (a) : (b)) 
//#define MIN(a,b) (((a) <= (b)) ? (a) : (b)) 




//---------------------------------------------------------------------------
typedef struct
{
        float x,y,theta,v,omega,deltav, deltavpoint;
		// on rajoute des variables d'tat pour faire tanguer le bateau
        float phi, phiPoint; 
}Etat;
//---------------------------------------------------------------------------
class Bateau
{

public:
        Etat etat;
        double beta, J, rg, rv, alphag, alphav, alphaf, alphatheta, l, V, m,mPassager;
        double fg,fv;
		double alphadeltav;
		
		// on rajoute le moment d'inertie selon l'axe du bateau Jv
        double Jv;
		double Jvoile;

        //on rajoute le coefficient li  la viscosit eta et la hauteur du vent hv qui s'abbat sur la voile
        double eta;
        double hv;
		
		// la gravit pour prendre en compte le poids du voilier et de ses passagers
        double g;

		// variables que l'on ajoute pour faire bouger la mer et le ciel
        // il s'agit de sorte de compteurs
        double mer,ciel;
	
        Bateau();
        void Incremente(int,int);
        void Draw();
		
};
//---------------------------------------------------------------------------




void Moteur();
void calcul_ut(int);
void output(int x, int y, int z, char *string);

#endif
