#include <windows.h>
#include <winbase.h>
#include <conio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "serie.h"

int commandNum(double num, double max, int * erreur)
{
	if(erreur!=NULL) *erreur=0;
	/*Calcul de la commande nurique*/
	int commande=floor((num/max)*(220-128)+128);   //tranforme [-max,max] en [0,255]

	/*verification de l'interval de commande et saturation*/
	if(commande>220) {
		commande = 220;
		if(erreur!=NULL) *erreur = 1;	
	}
	if(commande<35) {
		commande = 35;
		if(erreur!=NULL) *erreur = -1;
	}


	return commande;
}

int setCommand(BYTE tmp, HANDLE com)
{
        BYTE msg[6];
        msg[0]=0x80; //pololu Mode (voir documentation USB16 servo pololu)
        msg[1]=0x01; //device ID = 1 pour servocontroller
        msg[2]=0x03; //command
        msg[3]=0; //servo num
        //msg[4]=1 << 6;
        //msg[5]=~0x80;
        msg[4]= (tmp & 0x80) >> 7; //most significant bit
        msg[5]= tmp & ~0x80; //the other less significant bits
        return comsend(msg, 6, com);
}

//---------------------------------------------------------------------------
int cominit(char *nom_com, HANDLE *pcom)  // gestion comme en port serie classique (ici port 4)
{
		HANDLE com;
		DCB struc_dcb;
		
		/*initialisation du port serie*/
        *pcom = CreateFile(nom_com,  GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH | FILE_FLAG_NO_BUFFERING, NULL);
		com = *pcom;
        if(com == INVALID_HANDLE_VALUE)
        {
                printf("Erreur d'initialisation du port com...\n");
				return 1;
                
        }
        else
        {
				/*RAZ de tous les signaux*/
                PurgeComm(com, PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);

				/*taille de la liaison*/
                struc_dcb.DCBlength = sizeof(DCB);

				/*recupration de la structure DCB pour les paramtres de la liaison serie*/
                if(GetCommState(com, &struc_dcb)==0)
                        {
                                printf("Erreur de creation de la structure dcb...\n");
								return 1;
                        }

				/*baudrate*/
                struc_dcb.BaudRate=CBR_9600;
			
				
                 

				/*Nombre de bits*/
                struc_dcb.ByteSize=8;

				/*parite*/
                struc_dcb.Parity=NOPARITY; //'O' impair 'E' pair 'N' rien

				/*nombre de bit de stop*/
                struc_dcb.StopBits=ONESTOPBIT;
                
				/*pas de control logiciel*/
                struc_dcb.fDtrControl=DTR_CONTROL_DISABLE;

				/*mise  jour des nouvelles valeurs de la structure*/
                SetCommState(com, &struc_dcb);

                
        }
		return 0;
}



int comsend(const void *msg, unsigned int nbOctet, HANDLE com)
{
        DWORD NumBytes=0;
        if(com!=NULL)
        {
                if(WriteFile(com, msg, nbOctet, &NumBytes, NULL)==0)
                {
                        printf("Erreur de transmission...\n");
						return 1;
                }

        }
        else
        {        printf("Port non ouvert...\n");
				 return 1;
        }
		return 0;
}

void comclose(HANDLE com)
{
        if(com!=NULL)
        {
                CloseHandle(com);
        }
}